RengarusGrimFocus = {}
RengarusGrimFocus.name = "RengarusGrimFocus"
RengarusGrimFocus.version= "2.1"

RengarusGrimFocus.Default = {
	targetHotbar = 0,
	targetSlot = 5,
	alternativeDamage = false,
	targetHotbarDamage = 0,
	targetSlotDamage = 5,
	alternativeHealer = false,
	targetHotbarHealer = 0,
	targetSlotHealer = 5,
	alternativeTank = false,
	targetHotbarTank = 0,
	targetSlotTank = 5,
	debugMessages = false,
	backupHotbar = 0,
	backupSlot = 5,
	backupSkill = 0,
	isSwapped = false,
}

local LAM2 = LibAddonMenu2

local resetPending = false
local effectiveTargetHotbar
local effectiveTargetSlot
local legalMap = false
local currentStacks = 0

--Grim Focus
local ID_GrimFocus = 61902
local ID_MercilessResolve = 61919
local ID_RelentlessFocus = 61927

local function IsGrimFocus(abilityId)
	if abilityId == ID_GrimFocus or abilityId == ID_MercilessResolve  or abilityId == ID_RelentlessFocus then
		return true
	end
end

--Grim Focus Stack
local ID_GrimFocusStack = 122585 --61905
local ID_MercilessResolveStack = 122586 --61920
local ID_RelentlessFocusStack = 122587 --61928

local function IsGrimFocusStack(abilityId)
	if abilityId == ID_GrimFocusStack or abilityId == ID_MercilessResolveStack or abilityId == ID_RelentlessFocusStack then
		return true
	end
end

--Core Functions
local function EquipGrimFocus(state)
	if state == true then
		RengarusGrimFocus.savedVariables.backupSkill = GetSlotBoundId((effectiveTargetSlot + 2))
		RengarusGrimFocus.savedVariables.backupSlot = effectiveTargetSlot
		RengarusGrimFocus.savedVariables.backupHotbar = GetActiveHotbarCategory()
		SlotSkillAbilityInSlot(1, 1, 6, (effectiveTargetSlot + 2))
		RengarusGrimFocus.savedVariables.isSwapped = true
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] Grim Focus slotted. (Saved "..GetAbilityName(RengarusGrimFocus.savedVariables.backupSkill).." in Slot "..RengarusGrimFocus.savedVariables.backupSlot..")")
		end
	else
		local skillType, skillLineIndex, skillIndex = GetSpecificSkillAbilityKeysByAbilityId(RengarusGrimFocus.savedVariables.backupSkill)
		SlotSkillAbilityInSlot(skillType, skillLineIndex, skillIndex, (RengarusGrimFocus.savedVariables.backupSlot + 2))
		RengarusGrimFocus.savedVariables.isSwapped = false
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] Grim Focus unslotted. (Equiped "..GetAbilityName(RengarusGrimFocus.savedVariables.backupSkill).." to Slot "..RengarusGrimFocus.savedVariables.backupSlot..")")
		end
	end
end

local function CheckStacks()
	currentStacks = 0
	if GetNumBuffs("player") > 0 then
		for i = 1, GetNumBuffs("player") do
			local buffName, _, _, _, stackCount, _, _, _, _, _, abilityId = GetUnitBuffInfo("player", i)
			--d("-----------",buffName,stackCount,abilityId)
			if IsGrimFocusStack(abilityId) then
				currentStacks = stackCount
				return
			end
		end
	end
end

local function CheckConditions()
	if RengarusGrimFocus.savedVariables.debugMessages == true then
		--d("[RGF] Stacks: "..currentStacks.." Legal Map: "..tostring(legalMap).." IsSwapped: "..tostring(RengarusGrimFocus.savedVariables.isSwapped))
	end
	if GetActiveHotbarCategory() == effectiveTargetHotbar and IsSkillAbilityPurchased(1, 1, 6) then
		if currentStacks < 5 and legalMap == true and GetAssignedSlotFromSkillAbility(1, 1, 6) == nil then
			EquipGrimFocus(true)
		elseif RengarusGrimFocus.savedVariables.isSwapped == true and (currentStacks >= 5 or legalMap == false) and GetActiveHotbarCategory() == RengarusGrimFocus.savedVariables.backupHotbar then
			EquipGrimFocus(false)
		end
	end
end

local function ResetGrimFocus()
	if  IsUnitInCombat("player") and RengarusGrimFocus.savedVariables.isSwapped == true then
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] Waiting for Combat to end.")
		end
		resetPending = true
	elseif not (GetActiveHotbarCategory() == RengarusGrimFocus.savedVariables.backupHotbar) and RengarusGrimFocus.savedVariables.isSwapped == true then
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] Waiting for correct Bar to be equiped.")
		end
		resetPending = true
	elseif RengarusGrimFocus.savedVariables.isSwapped == true then
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] Reseting...")
		end
		zo_callLater(function () EquipGrimFocus(false) end, 1000)
		zo_callLater(function () CheckConditions() end, 2000)
	else
		zo_callLater(function () CheckConditions() end, 1000)
	end
end

local function CheckEffectiveValues()
	if IsUnitInDungeon("player") and IsActiveWorldGroupOwnable() and GetSelectedLFGRole() == 1 and RengarusGrimFocus.savedVariables.alternativeDamage then
		effectiveTargetHotbar = RengarusGrimFocus.savedVariables.targetHotbarDamage
		effectiveTargetSlot = RengarusGrimFocus.savedVariables.targetSlotDamage
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			if effectiveTargetHotbar == 0 then
				d("[RGF] Using Damage Dealer settings. (Slot "..effectiveTargetSlot.." on Frontbar).")
			elseif effectiveTargetHotbar == 1 then
				d("[RGF] Using Damage Dealer settings. (Slot "..effectiveTargetSlot.." on Backbar).")
			else
				d("[RGF] Using Damage Dealer settings. (No Automatic slotting).")
			end
		end
	elseif IsUnitInDungeon("player") and IsActiveWorldGroupOwnable() and GetSelectedLFGRole() == 4 and RengarusGrimFocus.savedVariables.alternativeHealer then
		effectiveTargetHotbar = RengarusGrimFocus.savedVariables.targetHotbarHealer
		effectiveTargetSlot = RengarusGrimFocus.savedVariables.targetSlotHealer
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			if effectiveTargetHotbar == 0 then
				d("[RGF] Using Healer settings. (Slot "..effectiveTargetSlot.." on Frontbar)")
			elseif effectiveTargetHotbar == 1 then
				d("[RGF] Using Healer settings. (Slot "..effectiveTargetSlot.." on Backbar)")
			else
				d("[RGF] Using Healer settings. (No Automatic slotting)")
			end
		end
	elseif IsUnitInDungeon("player") and IsActiveWorldGroupOwnable() and GetSelectedLFGRole() == 2 and RengarusGrimFocus.savedVariables.alternativeTank then
		effectiveTargetHotbar = RengarusGrimFocus.savedVariables.targetHotbarTank
		effectiveTargetSlot = RengarusGrimFocus.savedVariables.targetSlotTank
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			if effectiveTargetHotbar == 0 then
				d("[RGF] Using Tank settings. (Slot "..effectiveTargetSlot.." on Frontbar)")
			elseif effectiveTargetHotbar == 1 then
				d("[RGF] Using Tank settings. (Slot "..effectiveTargetSlot.." on Backbar)")
			else
				d("[RGF] Using Tank settings. (No Automatic slotting)")
			end
		end
	else
		effectiveTargetHotbar = RengarusGrimFocus.savedVariables.targetHotbar
		effectiveTargetSlot = RengarusGrimFocus.savedVariables.targetSlot
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			if effectiveTargetHotbar == 0 then
				d("[RGF] Using Overland settings. (Slot "..effectiveTargetSlot.." on Frontbar)")
			elseif effectiveTargetHotbar == 1 then
				d("[RGF] Using Overland settings. (Slot "..effectiveTargetSlot.." on Backbar)")
			else
				d("[RGF] Using Overland settings. (No Automatic slotting)")
			end
		end
	end
end

--Trigger Functions
local function OnPlayerActivated()
	if GetMapContentType() == MAP_CONTENT_AVA or GetMapContentType() == MAP_CONTENT_BATTLEGROUND or IsUnitPvPFlagged("player") then
		legalMap = false
		if RengarusGrimFocus.savedVariables.debugMessages == true then
			d("[RGF] PvP map detected. (No Automatic slotting)")
		end
	else
		legalMap = true
		CheckEffectiveValues()
	end
	CheckStacks()
	ResetGrimFocus()
end

local function OnCombatState(eventCode, inCombat)
	if inCombat == false then
		if resetPending == false then
			CheckStacks()
			CheckConditions()
		else
			resetPending = false
			CheckStacks()
			ResetGrimFocus()
		end
	end
end

local function OnHotbarSwap(eventCode, didActiveHotbarChange, shouldUpdateAbilityAssignments, activeHotbarCategory)
	if not IsUnitInCombat("player") and didActiveHotbarChange == true then
		if resetPending == false then
			CheckStacks()
			CheckConditions()
		else
			resetPending = false
			CheckStacks()
			ResetGrimFocus()
		end
	end
end

local function OnRoleChanged(eventCode, unitTag, assignedRole)
	if AreUnitsEqual("player", unitTag) then
		CheckEffectiveValues()
		CheckStacks()
		ResetGrimFocus()
	end
end

local function OnSlotChange(hotbarCategory, actionSlotIndex, isChangedByPlayer)
	if (not IsUnitInCombat("player")) and hotbarCategory == effectiveTargetHotbar and isChangedByPlayer == true then
		if IsGrimFocus(GetSlotBoundId(actionSlotIndex)) and actionSlotIndex == (effectiveTargetSlot + 2) and RengarusGrimFocus.savedVariables.isSwapped == true then
			RengarusGrimFocus.savedVariables.backupSkill = GetSlotBoundId((effectiveTargetSlot + 2))
			RengarusGrimFocus.savedVariables.isSwapped = false
			if RengarusGrimFocus.savedVariables.debugMessages == true then
				d("[RGF] Saved "..GetAbilityName(RengarusGrimFocus.savedVariables.backupSkill).." in Slot "..RengarusGrimFocus.savedVariables.backupSlot..".")
			end
		end
		CheckStacks()
		zo_callLater(function () CheckConditions() end, 250)
	end
end

--Settings Window
local function CreateSettingsWindow()
	local panelData = {
		type = "panel",
		name = "Rengaru's Grim Focus",
		displayName = "Rengaru's Grim Focus",
		author = "Rengaru",
		version = RengarusGrimFocus.version,
		registerForRefresh = true,
	} 
	local cntrlOptionsPanel = LAM2:RegisterAddonPanel("RengarusGrimFocus_SettingsPanel", panelData)
	local optionsData = {
		[1] = {
			type = "dropdown",
			name = "Target Hotbar",
			tooltip = "Which Hotbar should Grim Focus automatically be equiped on?",
			choices = {"Frontbar", "Backbar", "None"},
			choicesValues = {0, 1, 2},
			default = 0,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetHotbar end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetHotbar = newValue OnPlayerActivated() end,
		},
		[2] = {
			type = "slider",
			name = "Select Slot",
			tooltip = "Which Slot should Grim Focus automatically be equiped on?",
			min = 1,
			max = 5,
			step = 1,
			default = 5,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetSlot end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetSlot = newValue OnPlayerActivated() end,
		},
		[3] = {
			type = "divider",
			height = 15,
			alpha = 0.5,
			width = "full"
		},
		[4] = {
			type = "checkbox",
			name = "Alternative Damage",
			tooltip = "Should we use a different behaviour when playing as a Damage Dealer in Dungeons or Trials?",
			default = false,
			getFunc = function() return RengarusGrimFocus.savedVariables.alternativeDamage end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.alternativeDamage = newValue OnPlayerActivated() end,
		},
		[5] = {
			type = "dropdown",
			name = "Target Hotbar (Damage)",
			tooltip = "Which Hotbar should Grim Focus automatically be equiped on when playing as a Damage Dealer in Dungeons or Trials?",
			choices = {"Frontbar", "Backbar", "None"},
			choicesValues = {0, 1, 2},
			default = 0,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeDamage end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetHotbarDamage end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetHotbarDamage = newValue OnPlayerActivated() end,
		},
		[6] = {
			type = "slider",
			name = "Select Slot (Damage)",
			tooltip = "Which Slot should Grim Focus automatically be equiped on when playing as a Damage Dealer in Dungeons or Trials?",
			min = 1,
			max = 5,
			step = 1,
			default = 5,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeDamage end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetSlotDamage end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetSlotDamage = newValue OnPlayerActivated() end,
		},
		[7] = {
			type = "divider",
			height = 5,
			alpha = 0.5,
			width = "half"
		},
		[8] = {
			type = "checkbox",
			name = "Alternative Healer",
			tooltip = "Should we use a different behaviour when playing as a Healer in Dungeons or Trials?",
			default = false,
			getFunc = function() return RengarusGrimFocus.savedVariables.alternativeHealer end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.alternativeHealer = newValue OnPlayerActivated() end,
		},
		[9] = {
			type = "dropdown",
			name = "Target Hotbar (Healer)",
			tooltip = "Which Hotbar should Grim Focus automatically be equiped on when playing as a Healer in Dungeons or Trials?",
			choices = {"Frontbar", "Backbar", "None"},
			choicesValues = {0, 1, 2},
			default = 0,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeHealer end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetHotbarHealer end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetHotbarHealer = newValue OnPlayerActivated() end,
		},
		[10] = {
			type = "slider",
			name = "Select Slot (Healer)",
			tooltip = "Which Slot should Grim Focus automatically be equiped on when playing as a Healer in Dungeons or Trials?",
			min = 1,
			max = 5,
			step = 1,
			default = 5,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeHealer end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetSlotHealer end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetSlotHealer = newValue OnPlayerActivated() end,
		},
		[11] = {
			type = "divider",
			height = 5,
			alpha = 0.5,
			width = "half"
		},
		[12] = {
			type = "checkbox",
			name = "Alternative Tank",
			tooltip = "Should we use a different behaviour when playing as a Tank in Dungeons or Trials?",
			default = false,
			getFunc = function() return RengarusGrimFocus.savedVariables.alternativeTank end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.alternativeTank = newValue OnPlayerActivated() end,
		},
		[13] = {
			type = "dropdown",
			name = "Target Hotbar (Tank)",
			tooltip = "Which Hotbar should Grim Focus automatically be equiped on when playing as a Tank in Dungeons or Trials?",
			choices = {"Frontbar", "Backbar", "None"},
			choicesValues = {0, 1, 2},
			default = 0,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeTank end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetHotbarTank end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetHotbarTank = newValue OnPlayerActivated() end,
		},
		[14] = {
			type = "slider",
			name = "Select Slot (Tank)",
			tooltip = "Which Slot should Grim Focus automatically be equiped on when playing as a Tank in Dungeons or Trials?",
			min = 1,
			max = 5,
			step = 1,
			default = 5,
			disabled = function() return not RengarusGrimFocus.savedVariables.alternativeTank end,
			getFunc = function() return RengarusGrimFocus.savedVariables.targetSlotTank end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.targetSlotTank = newValue OnPlayerActivated() end,
		},
		[15] = {
			type = "divider",
			height = 15,
			alpha = 0.5,
			width = "full"
		},
		[16] = {
			type = "checkbox",
			name = "Debug",
			tooltip = "Enable Debug Messages?",
			default = false,
			getFunc = function() return RengarusGrimFocus.savedVariables.debugMessages end,
			setFunc = function(newValue) RengarusGrimFocus.savedVariables.debugMessages = newValue end,
		},
	}
	LAM2:RegisterOptionControls("RengarusGrimFocus_SettingsPanel", optionsData)
end

--Setup
local function OnAddOnLoaded(event, addonName)
	if addonName == RengarusGrimFocus.name then
		EVENT_MANAGER:UnregisterForEvent(RengarusGrimFocus.name, EVENT_ADD_ON_LOADED)
		if GetUnitClass("player") == GetClassName(1,3) or GetUnitClass("player") == GetClassName(2,3) then
			EVENT_MANAGER:RegisterForEvent(RengarusGrimFocus.name, EVENT_PLAYER_ACTIVATED, OnPlayerActivated)
			EVENT_MANAGER:RegisterForEvent(RengarusGrimFocus.name, EVENT_PLAYER_COMBAT_STATE, OnCombatState)
			EVENT_MANAGER:RegisterForEvent(RengarusGrimFocus.name, EVENT_ACTION_SLOTS_ACTIVE_HOTBAR_UPDATED, OnHotbarSwap)
			EVENT_MANAGER:RegisterForEvent(RengarusGrimFocus.name, EVENT_GROUP_MEMBER_ROLE_CHANGED, OnRoleChanged)
			ACTION_BAR_ASSIGNMENT_MANAGER:RegisterCallback("SlotUpdated", function(hotbarCategory, actionSlotIndex, isChangedByPlayer) OnSlotChange(hotbarCategory, actionSlotIndex, isChangedByPlayer) end)
			RengarusGrimFocus.savedVariables = ZO_SavedVars:NewCharacterIdSettings("RengarusGrimFocus_SavedVars", RengarusGrimFocus.version, nil, RengarusGrimFocus.Default)
			CreateSettingsWindow()
		end
	end
end

EVENT_MANAGER:RegisterForEvent(RengarusGrimFocus.name, EVENT_ADD_ON_LOADED, OnAddOnLoaded)